/* $Header: /home/yav/catty/xpx/xpx/RCS/edit.c,v 1.23 1994/11/03 13:16:23 yav Exp $
 */

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <stdio.h>

#include "config.h"

#ifdef HAVE_STRING_H
#include <string.h>
#else
#ifdef HAVE_STRINGS_H
#include <strings.h>
#endif
#endif

#include <math.h>

#include "xpx.h"
#include "extern.h"
#include "editdef.h"
#include "menudef.h"
#include "cursdef.h"

extern MENU cursmenu[];

#define AUTOSAVETIME 30

#define EDITWINW 225
#define EDITWINH (EDITWINH2+8+(BDW+EDMH+BDW)+4)
#define EDITWINH2 ((EDMH+BDW)*EDIT_ONGRID+BDW+8+(BDW+EDMH+BDW))

#define EDMW	64
#define EDMH	24

/* image.c */
extern AREA area0;
extern Bool area_flag;
/* undo.c */
extern int undo_cnt;
/* image.c */
extern max_area();
extern Bool mark_flag;
/* sub.c */
extern void cursor_busy(
#if NeedFunctionPrototypes
			void
#endif
			);

static char rcs_id[] = "$Id: edit.c,v 1.23 1994/11/03 13:16:23 yav Exp $";

static Window editfuncwin[3];
static int edit_mode[3] = {EDIT_PLOT, EDIT_GETCOLOR, EDIT_GETCOLOR};
static int area_mode = 0;
static int circle_mode = 0;
static int line_mode = 0;
static POS copypos0, copysrc0, copysrc1;
static AREA copydst;

#define IMASK (ExposureMask|EnterWindowMask|LeaveWindowMask|ButtonPressMask)
int edev();
int edev2();
#define EMSTRUC(num,name) {(num), MenuModeMaskBorder,\
			     0, (EDMH+BDW)*(num), EDMW, EDMH,\
			       0, IMASK, 0,\
				 edev, NULL, 0, 0, name}

static MENU menutbl[] = {
  {
    EDIT_dummy,	0,
    0, 0, EDMW, EDMH,
    0, ExposureMask, 0,
    NULL, NULL, 0, 0, "Button?"
    },
      EMSTRUC(EDIT_PLOT, "Plot"),
      EMSTRUC(EDIT_COPY, "Copy"),
      EMSTRUC(EDIT_FILL, "Boxfull"),
      EMSTRUC(EDIT_LINE, "line"),
      EMSTRUC(EDIT_CIRCLE, "circle"),
      EMSTRUC(EDIT_ELLIPSE, "ellipse"),
      EMSTRUC(EDIT_PAINT, "paint"),
      EMSTRUC(EDIT_GETCOLOR, "get"),
      EMSTRUC(EDIT_SCROLL, "scroll"),
      EMSTRUC(EDIT_HOTSPOT, "hotspot"),
      EMSTRUC(EDIT_GRID, "grid"),
      EMSTRUC(EDIT_CANCEL, "cancel"),
      {
	EDIT_ONGRID,	MenuModeMaskBorder,
	0, (EDMH+BDW)*EDIT_ONGRID+BDW+8, EDMW, EDMH,
	0, IMASK, 0,
	NULL, NULL, 0, 0, "on grid"},
  {
    -1,	0,
    0, 0, 0, 0,
    0, 0, 0,
    NULL, NULL, 0, 0, NULL}};

char *edev2str();
static MENU editmenu2[] = {
  {
    EDIT2_UNDO,	MenuModeMaskBorder,
    4, BDW*2+4, EDMW+16, EDMH,
    0, IMASK, SouthWestGravity,
    edev2, edev2str, 0, 16, NULL},
  {
    EDIT2_OK,	MenuModeMaskBorder,
    BDW*2+4, BDW*2+4, EDMW, EDMH,
    0, IMASK, SouthEastGravity,
    edev2, NULL, 0, 0, "OK"},
  {
    -1,	0,
    0, 0, 0, 0,
    0, 0, 0,
    NULL, NULL, 0, 0, NULL}};
MENU *menutblp[3];

static int *ptsbuf = NULL;

create_edit_window()
{
  int i;
  static char *titles[3] = {"Button1", "Button2", "Button3"};
  
  ptsbuf = (int*)malloc(sizeof(int)*8*(imgmaxw+imgmaxh));
  
  create_toplevel_window(&editwin, "edit", str_edit_geom, EDITWINW, EDITWINH);
  XSelectInput(dsp, editwin, ExposureMask);
  for (i = 0; i < 3; i++) {
    editfuncwin[i] = XCreateSimpleWindow(dsp, editwin,
					 4+(EDMW+BDW*2+4)*i, 0,
					 EDMW+BDW*2, EDITWINH2,
					 0, fg, bg);
    XSelectInput(dsp, editfuncwin[i], ExposureMask);
    XMapWindow(dsp, editfuncwin[i]);
    menutblp[i] = (MENU *)malloc(sizeof(menutbl));
    bcopy(menutbl, menutblp[i], sizeof(menutbl));
    menutblp[i]->str = titles[i];
    menutblp[i]->cursor = i;
    (menutblp[i]+edit_mode[i])->mode |= MenuModeMaskOn;
    menuwin_create(menutblp[i], editfuncwin[i], 0, 0);
  }
  menuwin_create(editmenu2, editwin, 0, 0);
  return 0;
}

map_edit_window()
{
  XMapRaised(dsp, editwin);
}

unmap_edit_window()
{
  XUnmapWindow(dsp, editwin);
}

close_edit_window()
{
  XDestroyWindow(dsp, editwin);
}

area_mode_reset()
{
  area_flag = False;
  area_mode = line_mode = circle_mode = 0;
  copy_area_expose();
}

edit_mode_change2(button, mode)
{
  area_mode_reset();
  if (mode != edit_mode[button]) {
    (menutblp[button]+edit_mode[button])->mode &= ~MenuModeMaskOn;
    redraw_window((menutblp[button]+edit_mode[button])->win);
    edit_mode[button] = mode;
    (menutblp[button]+edit_mode[button])->mode |= MenuModeMaskOn;
    redraw_window((menutblp[button]+edit_mode[button])->win);
  }
}

edit_mode_change(n)
{
  edit_mode_change2(0, n);
}

/* sub.c */
extern MENU *get_top_menu();

int edev(p, ev)
     MENU *p;
     XEvent *ev;
{
  switch(ev->type) {
  case ButtonPress:
    edit_mode_change2(get_top_menu(p)->cursor, p->n);
    return 1;
  }
  return 0;
}

int edev2(p, ev)
     MENU *p;
     XEvent *ev;
{
  switch(ev->type) {
  case ButtonPress:
    switch(p->n) {
    case EDIT2_UNDO:
      cursor_busy();
      undo_pull();
      p->mode &= ~MenuModeMaskOn;
      redraw_window(p->win);
      return 1;
    case EDIT2_OK:
      p->mode &= ~MenuModeMaskOn;
      menu_stat_change(MENU_EDIT, 0);
      return 1;
    }
  }
  return 0;
}

char *edev2str(p)
     MENU *p;
{
  switch(p->n) {
  case EDIT2_UNDO:
    if (undo_cnt >= MAXUNDO)
      strcpy(p->str, "undo MAX");
    else
      sprintf(p->str, "undo %d", undo_cnt);
    break;
  }
  return p->str;
}

edit_undo_update()
{
  static int last_undo_cnt = -1;
  
  if (undo_cnt != last_undo_cnt) {
    redraw_window(editmenu2[EDIT2_UNDO].win);
    last_undo_cnt = undo_cnt;
  }
}

/*********************************
 * image edit function
 */

area_img_expose(x, y, w, h)
{
  calc_img_area(&x, &y, &w, &h);
  img_expose(x, y, w, h);
}

plot(x, y, c)
{
  setpixelcolor(x, y, c);
  if (vimg != NULL)
    XClearArea(dsp, viewwin, x, y, 1, 1, True);
  img_expose(x*zoomfactor-imgofsx, y*zoomfactor-imgofsy,
	     zoomfactor, zoomfactor);
}

/* Window update */
area_update(x, y, w, h)
{
  if (vimg != NULL)
    XClearArea(dsp, viewwin, x, y, w, h, True);
  area_img_expose(x, y, w, h);
  copy_area_expose();
}

copy(dstx, dsty, srcx, srcy, w, h)
{
  if (!w || !h)
    return;
  undo_push_area(dstx, dsty, w, h);
  copy_area(dstx, dsty, srcx, srcy, w, h);
  area_update(dstx, dsty, w, h);
}

fill(x, y, w, h, c)
{
  if (!w || !h)
    return;
  undo_push_area(x, y, w, h);
  fill_area(x, y, w, h, c);
  area_update(x, y, w, h);
}

edit_plot(x, y)
{
  if (current_col >= 0 && *(imgdata+y*imgmaxw+x) != current_col) {
    undo_push_plot(x, y, *(imgdata+y*imgmaxw+x), current_col);
    plot(x, y, current_col);
  }
}

edit_copy_and_fill(x, y, type, em)
{
  if (type == ButtonPress) {
    switch(area_mode) {
    case 2:
      if (inarea(x, 1, copysrc0.x, copysrc1.x)&&
	  inarea(y, 1, copysrc0.y, copysrc1.y)) {
	/* area catch */
	copydst.x = x - copysrc0.x;
	copydst.y = y - copysrc0.y;
	copydst.w = copysrc1.x - copysrc0.x;
	copydst.h = copysrc1.y - copysrc0.y;
	area_mode = 3;
	break;
      }
    case 0:
      /* area mark start */
      copypos0.x = x;
      copypos0.y = y;
      area_mode = 1;
      break;
    }
  } else if (type == ButtonRelease) {
    switch(area_mode) {
    case 3:
      /* paste */
      copy(area0.x, area0.y, copysrc0.x, copysrc0.y,
	   copysrc1.x - copysrc0.x, copysrc1.y - copysrc0.y);
    case 1:
      /* area mark end */
      copysrc0.x = area0.x;
      copysrc0.y = area0.y;
      copysrc1.x = area0.w;
      copysrc1.y = area0.h;
      little_big(&copysrc0.x, &copysrc1.x);
      little_big(&copysrc0.y, &copysrc1.y);
      switch(em) {
      case EDIT_FILL:
	area_flag = False;
	area_mode = 0;
	fill(copysrc0.x, copysrc0.y,
	     copysrc1.x-copysrc0.x, copysrc1.y-copysrc0.y, current_col);
	break;
      case EDIT_COPY:
	area_mode = 2;
	break;
      }
      break;
    }
  }
  if (type == MotionNotify) {
    switch(area_mode) {
    case 1:
      /* area size update */
      if (x != area0.w || y != area0.h) {
	area0.w = x;
	area0.h = y;
	area0.x = copypos0.x;
	area0.y = copypos0.y;
	area_flag = True;
	copy_area_expose();
      }
      break;
    case 3:
      /* drug area */
      x -= copydst.x;
      if (x < 0)
	x = 0;
      if (x + copydst.w > imgfilew)
	x = imgfilew - copydst.w;
      y -= copydst.y;
      if (y < 0)
	y = 0;
      if (y + copydst.h > imgfileh)
	y = imgfileh - copydst.h;
      if (x != area0.x || y != area0.y) {
	area0.x = x;
	area0.y = y;
	area0.w = x + copydst.w;
	area0.h = y + copydst.h;
	copy_area_expose();
      }
      break;
    }
  }
}

#ifndef abs
#define abs(x) ((x)<0?-(x):(x))
#endif

plots(p, n)
     int *p;
     int n;
{
  int i, x, y, x0, y0, x1, y1;
  
  if (current_col < 0 || n <= 0)
    return;
  /* check update area */
  max_area(&x0, &y0, &x1, &y1, n, p);
  undo_push_area(x0, y0, x1-x0+1, y1-y0+1);
  while (n--) {
    x = *p++;
    y = *p++;
    if (x >= 0 && x < imgmaxw && y >= 0 && y < imgmaxh) {
      setpixelcolor(x, y, current_col);
    }
  }
  if (vimg != NULL)
    XClearArea(dsp, viewwin, x0, y0, x1-x0+1, y1-y0+1, True);
  img_expose(x0*zoomfactor-imgofsx, y0*zoomfactor-imgofsy,
	     (x1-x0+1)*zoomfactor, (y1-y0+1)*zoomfactor);
}

edit_line(x, y, type)
{
  int i;
  static int x0, y0, x1, y1;
  
  switch(type) {
  case ButtonPress:
    x0 = x;
    y0 = y;
    x1 = y1 = -1;
    line_mode = 1;
    break;
  case ButtonRelease:
    if (line_mode == 1) {
      i = line(ptsbuf, x0, y0, x, y);
      mark_flag = False;
      mark_pts_expose();
      plots(ptsbuf, i);
      line_mode = 0;
    }
    break;
  case MotionNotify:
    if (line_mode == 1 && (x != x1 || y != y1)) {
      mark_flag = False;
      mark_pts_expose();
      i = line(ptsbuf, x0, y0, x, y);
      mark_pts_set(i, ptsbuf);
      mark_flag = True;
      mark_pts_expose();
      x1 = x;
      y1 = y;
    }
    break;
  }
}

edit_circle_and_ellipse(x, y, type, em)
{
  int i, rx, ry;
  static int x0, y0, x1, y1;
  
  switch(type) {
  case ButtonPress:
    x0 = x;
    y0 = y;
    x1 = y1 = -1;
    circle_mode = 1;
    break;
  case ButtonRelease:
    if (circle_mode == 1) {
      rx = abs(x-x0);
      ry = abs(y-y0);
      if (em == EDIT_CIRCLE)
	ry = rx = ry>rx?ry:rx;
      if (rx > 0 && ry > 0) {
	if (em == EDIT_CIRCLE)
	  i = circle(ptsbuf, x0, y0, rx);
	else
	  i = ellipse(ptsbuf, x0, y0, rx, ry);
	mark_flag = False;
	mark_pts_expose();
	plots(ptsbuf, i);
      }
      area_flag = False;
      copy_area_expose();
      circle_mode = 0;
    }
    break;
  case MotionNotify:
    if (circle_mode == 1 && (x != x1 || y != y1)) {
      rx = abs(x-x0);
      ry = abs(y-y0);
      if (em == EDIT_CIRCLE)
	ry = rx = ry>rx?ry:rx;
      if (rx > 0 && ry > 0) {
	mark_flag = False;
	mark_pts_expose();
	if (em == EDIT_CIRCLE)
	  i = circle(ptsbuf, x0, y0, rx);
	else
	  i = ellipse(ptsbuf, x0, y0, rx, ry);
	mark_pts_set(i, ptsbuf);
	mark_flag = True;
	mark_pts_expose();
      }
      x1 = x;
      y1 = y;
    }
    break;
  }
}


edit_paint(x, y, type)
{
  extern int painted_pixel;	/* paint.c */
  
  switch(type) {
  case ButtonPress:
    cursor_busy();
    undo_push_area(0, 0, imgfilew, imgfileh);
    painted_pixel = *(imgdata+y*imgmaxw+x);
    paint(x, y);
#if 1
    area_update(0, 0, imgfilew, imgfileh);
#endif
    break;
  case ButtonRelease:
    break;
  }
}

img_button_sub(x, y, type, em, ox, oy)
{
  switch (em) {
  case EDIT_GETCOLOR:
    set_current_color(*(imgdata+y*imgmaxw+x));
    break;
  case EDIT_PLOT:
    edit_plot(x, y);
    break;
  case EDIT_COPY:
  case EDIT_FILL:
    edit_copy_and_fill(x, y, type, em);
    break;
  case EDIT_LINE:
    edit_line(x, y, type);
    break;
  case EDIT_CIRCLE:
  case EDIT_ELLIPSE:
    edit_circle_and_ellipse(x, y, type, em);
    break;
  case EDIT_PAINT:
    edit_paint(x, y, type);
    break;
  case EDIT_SCROLL:
    switch(type) {
    case ButtonPress:
      /* set background scroll */
      if (ox < imgwinwidth/3)
	scroll_ax = -1;
      if (ox >= imgwinwidth*2/3)
	scroll_ax = 1;
      if (oy < imgwinheight/3)
	scroll_ay = -1;
      if (oy >= imgwinheight*2/3)
	scroll_ay = 1;
      break;
    case ButtonRelease:
      /* reset background scroll */
      scroll_dx = scroll_dy = 0;
      scroll_ax = scroll_ay = 0;
      break;
    }
    break;
  case EDIT_GRID:
    if (type == ButtonPress) {
      grid_ofsx = x % grid_size;
      grid_ofsy = y % grid_size;
      set_image_size(-1, -1);
      area_mode_reset();
    }
    break;
  case EDIT_HOTSPOT:
    if (type == ButtonPress) {
      if (x == hotspotx && y == hotspoty)
	x = y = -1;
      hotspotx = x;
      hotspoty = y;
      set_image_size(-1, -1);
    }
    /* continue to next case */
  case EDIT_CANCEL:
  default:
    if (type == ButtonPress)
      area_mode_reset();
    mark_pts_expose();
    return;
  }
}

img_button(type, ox, oy, button, st)
     unsigned int st;
{
  int x, y, dx, dy, w, h, em;
  unsigned long pix;
  
  x = (ox + imgofsx) / zoomfactor;
  y = (oy + imgofsy) / zoomfactor;
  switch(button) {
  case Button1:
    em =  0;
    break;
  case Button2:
    em = 1;
    break;
  case Button3:
    em = 2;
    break;
  }
  if ((menutblp[em]+EDIT_ONGRID)->mode & MenuModeMaskOn) {
    dx = x % grid_size;
    x -= dx;
    if (dx > grid_size/2)
      x += grid_size;
    dy = y % grid_size;
    y -= dy;
    if (dy > grid_size/2)
      y += grid_size;
  }
  if (x < 0)
    x = 0;
  if (x >= imgfilew)
    x = imgfilew;
  if (y < 0)
    y = 0;
  if (y >= imgfileh)
    y = imgfileh;
  if (x != curx) {
    curx = x;
    redraw_window(cursmenu[CURS_CURX].win);
  }
  if (y != cury) {
    cury = y;
    redraw_window(cursmenu[CURS_CURY].win);
  }
  img_button_sub(x, y, type, edit_mode[em], ox, oy);
}

edit_event(ev)
     XEvent *ev;
{
  int x, y, button;
  static int savecnt = 0;
  extern Drawable get_event_window();
  
  if (get_event_window(ev) != imgwin)
    return;
  switch (ev->type) {
  case MotionNotify:
    x = ev->xmotion.x;
    y = ev->xmotion.y;
    if (ev->xmotion.state & Button1Mask)
      img_button(ev->type, x, y, Button1);
    if (ev->xmotion.state & Button2Mask)
      img_button(ev->type, x, y, Button2);
    if (ev->xmotion.state & Button3Mask)
      img_button(ev->type, x, y, Button3);
    break;
  case ButtonRelease:
    if (++savecnt >= AUTOSAVETIME) {
      autosave();
      savecnt = 0;
    }
  case ButtonPress:
    button = ev->xbutton.button;
    img_button(ev->type, ev->xbutton.x, ev->xbutton.y, ev->xbutton.button);
    break;
  }
}

/* End of file */
