/* $Header: /home/yav/catty/xpx/xpx/RCS/info.c,v 1.20 1994/11/10 23:29:18 yav Exp $
 */

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/keysym.h>
#include <stdio.h>

#include "config.h"

#include "xpx.h"
#include "extern.h"
#include "infodef.h"
#include "icondef.h"

#define INFOWIDTH 480
#define INFOHEIGHT 180
#define INFOMNX	4
#define INFOMNY	4
#define INFOMNH	24

#define VIEWX 8
#define VIEWY (INFOHEIGHT-1)

static char rcs_id[] = "$Id: info.c,v 1.20 1994/11/10 23:29:18 yav Exp $";

char *infostr();
int infoev();

MENU infomenu[] = {
  {
    INFOMENU_TITLE,	0,
    INFOMNX, INFOMNY, INFOWIDTH-INFOMNX, INFOMNH,
    0, ExposureMask, 0,
    NULL, infostr, 0, 64, NULL},
  {
    INFOMENU_MARK,	0,
    INFOMNX, INFOMNY, 16, 16,
    0, ExposureMask, 0,
    infoev, NULL, 0, 0, "Rei"},
  {
    INFOMENU_IMGFILE,	MenuModeMaskLeft,
    INFOMNX, INFOMNY+INFOMNH*1, 400, INFOMNH,
    0, ExposureMask, 0,
    infoev, infostr, 0, 64, NULL},
  {
    INFOMENU_IMGSIZE,	MenuModeMaskLeft,
    INFOMNX, INFOMNY+INFOMNH*2, 38, INFOMNH,
    0, ExposureMask, 0,
    NULL, NULL, 0, 0, "size:"},
  {
    INFOMENU_IMGWIDTH,	MenuModeMaskBorder,
    INFOMNX+38, INFOMNY+INFOMNH*2, 40, INFOMNH,
    0,
    ExposureMask|EnterWindowMask|LeaveWindowMask|KeyPressMask,
    0,
    infoev, NULL, 0, 8, NULL},
  {
    INFOMENU_IMGSIZEX,	0,
    INFOMNX+38+40+BDW*2, INFOMNY+INFOMNH*2, 16, INFOMNH,
    0, ExposureMask, 0,
    NULL, NULL, 0, 0, "x"},
  {
    INFOMENU_IMGHEIGHT,	MenuModeMaskBorder,
    INFOMNX+38+40+BDW*2+16, INFOMNY+INFOMNH*2, 40, INFOMNH,
    0,
    ExposureMask|EnterWindowMask|LeaveWindowMask|KeyPressMask,
    0,
    infoev, NULL, 0, 8, NULL},
  {
    INFOMENU_COLFILE,	MenuModeMaskLeft,
    INFOMNX, INFOMNY+INFOMNH*3+BDW*2, 400, INFOMNH,
    0, ExposureMask, 0,
    NULL, infostr, 0, 256, NULL},
  {
    INFOMENU_COLCOUNT,	MenuModeMaskLeft,
    INFOMNX, INFOMNY+INFOMNH*4+BDW*2, 300, INFOMNH,
    0, ExposureMask, 0,
    NULL, infostr, 0, 64, NULL},
  {
    INFOMENU_GRIDCOLOR,	MenuModeMaskBorder,
    INFOMNX, INFOMNY+INFOMNH*5+BDW*2, 100, 20,
    0, ExposureMask|EnterWindowMask|LeaveWindowMask|ButtonPressMask, 0,
    infoev, NULL, 0, 0, "grid color"},
  {
    INFOMENU_SCROLLSTOP,	MenuModeMaskBorder|MenuModeMaskOn,
    INFOMNX+100+BDW*2+4, INFOMNY+INFOMNH*5+BDW*2, 100, 20,
    0, ExposureMask|EnterWindowMask|LeaveWindowMask|ButtonPressMask, 0,
    infoev, NULL, 0, 0, "scroll stop"},
  {
    INFOMENU_GSCEL,	MenuModeMaskBorder,
    INFOMNX+100+BDW*2+4+100+BDW*2+4, INFOMNY+INFOMNH*5+BDW*2,
    100, 20,
    0, ExposureMask|EnterWindowMask|LeaveWindowMask|ButtonPressMask, 0,
    infoev, NULL, 0, 0, "cel/GS"},
  {
    INFOMENU_GSKCF,	MenuModeMaskBorder,
    INFOMNX+100+BDW*2+4+100+BDW*2+4+100+BDW*2+4, INFOMNY+INFOMNH*5+BDW*2,
    100, 20,
    0, ExposureMask|EnterWindowMask|LeaveWindowMask|ButtonPressMask, 0,
    infoev, NULL, 0, 0, "kcf/GS"},
  {
    INFOMENU_OK,	MenuModeMaskBorder,
    BDW*2+4, BDW*2+4, 50, 20,
    0,
    ExposureMask|EnterWindowMask|LeaveWindowMask|ButtonPressMask,
    SouthEastGravity,
    infoev, NULL, 0, 0, "OK"},
  {
    INFOMENU_HOTSPOT,	MenuModeMaskLeft,
    INFOMNX+156, INFOMNY+INFOMNH*2, 60, INFOMNH,
    0, ExposureMask, 0,
    NULL, NULL, 0, 0, "hotspot:"},
  {
    INFOMENU_HOTX,	MenuModeMaskBorder,
    INFOMNX+156+60, INFOMNY+INFOMNH*2, 40, INFOMNH,
    0,
    ExposureMask|EnterWindowMask|LeaveWindowMask|KeyPressMask,
    0,
    infoev, NULL, 0, 8, NULL},
  {
    INFOMENU_HOTSPOT2,	0,
    INFOMNX+156+60+40+BDW*2, INFOMNY+INFOMNH*2, 12, INFOMNH,
    0, ExposureMask, 0,
    NULL, NULL, 0, 0, ","},
  {
    INFOMENU_HOTY,	MenuModeMaskBorder,
    INFOMNX+156+60+40+BDW*2+12, INFOMNY+INFOMNH*2, 40, INFOMNH,
    0,
    ExposureMask|EnterWindowMask|LeaveWindowMask|KeyPressMask,
    0,
    infoev, NULL, 0, 8, NULL},
  {
    INFOMENU_HOTSPOTCENTER,	MenuModeMaskBorder,
    INFOMNX, INFOMNY+INFOMNH*6+BDW*2, 100, 20,
    0, ExposureMask|EnterWindowMask|LeaveWindowMask|ButtonPressMask, 0,
    infoev, NULL, 0, 0, "hotspot center"},
  {
    -1,	0,
    0, 0, 0, 0,
    0, 0, 0,
    NULL, NULL, 0, 0, NULL}
};

info_parm_set(p, n)
     MENU *p;
{
  sprintf(p->str, "%d", n);
  p->cursor = strlen(p->str);
  redraw_window(p->win);
}

info_imgsize_set()
{
  info_parm_set(infomenu+INFOMENU_IMGWIDTH, imgfilew);
  info_parm_set(infomenu+INFOMENU_IMGHEIGHT, imgfileh);
  info_parm_set(infomenu+INFOMENU_HOTX, hotspotx);
  info_parm_set(infomenu+INFOMENU_HOTY, hotspoty);
}

create_info_window()
{
  create_toplevel_window(&infowin, "info", str_info_geom,
			 INFOWIDTH, INFOHEIGHT);
  XSelectInput(dsp, infowin, ExposureMask);
  
  viewwin = XCreateSimpleWindow(dsp, infowin, VIEWX, VIEWY,
				imgmaxw, imgmaxh, BDW, fg, bg);
  XSelectInput(dsp, viewwin, ExposureMask|EnterWindowMask|LeaveWindowMask|
	       ButtonPressMask);
  XMapWindow(dsp, viewwin);
  menuwin_create(infomenu, infowin, 0, 0);
  info_imgsize_set();
  return 0;
}

unmap_info_window()
{
  infomenu[INFOMENU_OK].mode &= ~MenuModeMaskOn;
  XUnmapWindow(dsp, infowin);
}

map_info_window()
{
  XMapRaised(dsp, infowin);
}

close_info_window()
{
  XDestroyWindow(dsp, viewwin);
  XDestroyWindow(dsp, infowin);
}


char *infostr(p)
     MENU *p;
{
  static char buf[MAXPATHLEN+32];
  
  switch(p->n) {
  case INFOMENU_TITLE:
    sprintf(p->str, "%s %s", myname, xpx_version);
    break;
  case INFOMENU_IMGFILE:
    sprintf(p->str, "image file: %s", imgfilename);
    break;
  case INFOMENU_COLFILE:
    sprintf(p->str, "color file: %s", colfilename);
    break;
  case INFOMENU_COLCOUNT:
    sprintf(p->str, "color : %d (private %d common %d)",
	    alloced_color,
	    alloced_color-alloced_common_color,
	    alloced_common_color);
    break;
  }
  return p->str;
}

alloc_vimg()
{
  vimg = XCreateImage(dsp, DefaultVisual(dsp, scr), DefaultDepth(dsp, scr),
		      ZPixmap, 0, None, imgfilew, imgfileh, 32, 0);
  if (vimg == NULL)
    return 1;
  vimg->data = (char *)malloc(vimg->bytes_per_line * vimg->height);
  if (vimg->data == NULL)
    return 1;
  return 0;
}

free_vimg()
{
  if (vimg != NULL) {
    if (vimg->data != NULL)
      free(vimg->data);
    XFree((char *)vimg);
    vimg = NULL;
  }
}

make_view_image()
{
  if (view_sw & 1) {
    free_vimg();
    if (vimg == NULL) {
      if (alloc_vimg()) {
	message("!view image alloc error!\n");
	return 1;
      }
      gen_image_subv(0, 0, imgfilew, imgfileh);
    }
  }
  return 0;
}

redraw_view(ev)
     XEvent *ev;
{
  if (view_sw & 1) {
    if (vimg == NULL && make_view_image())
      view_sw &= ~1;
  }
  if (view_sw & 1) {
    XPutImage(dsp, viewwin, gc0, vimg, ev->xexpose.x, ev->xexpose.y,
	      ev->xexpose.x, ev->xexpose.y,
	      ev->xexpose.width, ev->xexpose.height);
  } else {
    if (ev->xexpose.count == 0) {
      menuwin_center(viewwin, imgmaxw, imgmaxh, "view off");
      XDrawLine(dsp, ev->xexpose.window, gc0, 0, 0, imgmaxw-1, imgmaxh-1);
      XDrawLine(dsp, ev->xexpose.window, gc0, imgmaxw-1, 0, 0, imgmaxh-1);
    }
  }
}

info_expose(ev)
     XEvent *ev;
{
  if (ev->xexpose.window == viewwin)
    redraw_view(ev);
}


info_press(ev)
     XEvent *ev;
{
  if (ev->xbutton.window == viewwin) {
    view_sw ^= 1;
    redraw_window(viewwin);
  }
}

int infoev(p, ev)
     MENU *p;
     XEvent *ev;
{
  switch(ev->type) {
  case KeyPress:
    {
      int i;
      KeySym key;
      char buf[16];
      
      i = XLookupString((XKeyEvent *)ev, buf, sizeof(buf)-1, &key, NULL);
      buf[i] = '\0';
      switch(key) {
      case XK_KP_Enter:
      case XK_Return:
	i = strtol(p->str, NULL, 0);
	switch(p->n) {
	case INFOMENU_IMGWIDTH:
	  set_image_size(i, -1);
	  break;
	case INFOMENU_IMGHEIGHT:
	  set_image_size(-1, i);
	  break;
	case INFOMENU_HOTX:
	  hotspotx = i;
	  set_image_size(-1, -1);
	  break;
	case INFOMENU_HOTY:
	  hotspoty = i;
	  set_image_size(-1, -1);
	  break;
	}
      }
    }
    return 0;
  case ButtonPress:
    switch(p->n) {
    case INFOMENU_HOTSPOTCENTER:
      p->mode ^= MenuModeMaskOn;
      img_expose(0, 0, imgwinwidth, imgwinheight);
      break;
    case INFOMENU_GRIDCOLOR:
      p->mode ^= MenuModeMaskOn;
      XSetForeground(dsp, gridgc, (p->mode & MenuModeMaskOn)?fg:bg);
      XSetForeground(dsp, grid0gc, (p->mode & MenuModeMaskOn)?fg:bg);
      img_expose(0, 0, imgwinwidth, imgwinheight);
      break;
    case INFOMENU_OK:
      p->mode ^= MenuModeMaskOn;
      menu_stat_change(2, 0);
      break;
    default:
      return 0;
    }
    redraw_window(p->win);
    return 1;
  case Expose:
    switch(p->n) {
    case INFOMENU_MARK:
      XCopyArea(dsp, icon_pixmap(ICON_mars), p->win, gc0,
		ev->xexpose.x, ev->xexpose.y,
		ev->xexpose.width, ev->xexpose.height,
		ev->xexpose.x, ev->xexpose.y);
      return 1;
    }
  }
  return 0;
}

/* End of file */
