/* $Header: /home/yav/catty/xpx/xpx/RCS/inputstr.c,v 1.6 1995/01/06 12:02:58 yav Exp $
 */

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/keysym.h>
#include <stdio.h>

static char rcs_id[] = "$Id: inputstr.c,v 1.6 1995/01/06 12:02:58 yav Exp $";

/*
 * buf:           str:
 *     abcdef         ghi
 *        ^- pos
 *               |
 *               v
 *     abcghidef
 *           ^- pos
 * return:
 *     insert character count
 */
int insert_string(
#if NeedFunctionPrototypes
	      char *buf, int bufsz, int pos, char *str)
#else
     buf, bufsz, pos, str)
     char *buf;
     char *str;
#endif
{
  int i;
  int srclen;
  char *p;
  
  srclen = strlen(str);
  /* move tail */
  i = strlen(buf+pos);
  if (pos + i + srclen >= bufsz)
    return 0;
  if (i == 0) {
    strcpy(buf+pos, str);
  } else {
    p = (char*)malloc(i+1);
    if (p == NULL)
      return 0;
    strcpy(p, buf+pos);
    strcpy(buf+pos+srclen, p);
    free(p);
    strncpy(buf+pos, str, srclen);
  }
  return srclen;
}

/* return != 0 cannot to delete
 */
int delete_character(
#if NeedFunctionPrototypes
		 char *buf, int pos)
#else
     buf, pos)
     char *buf;
#endif
{
  int i;
  char *p;
  
  i = strlen(buf) - pos;
  if (i > 0) {
    p = (char*)malloc(i+1);
    if (p != NULL) {
      strcpy(p, buf+pos+1);
      strcpy(buf+pos, p);
      free(p);
      return 0;
    }
  }
  return 1;
}

/* return redraw req. bit0:cursor bit1:string bit2:enter bit3:cancel
 */
int edit_string(
#if NeedFunctionPrototypes
	    XKeyEvent *ev, char *buffer, int bufferlen, int *cursor)
#else
     ev, buffer, bufferlen, cursor)
     XKeyEvent *ev;
     char *buffer;
     int *cursor;
#endif
{
  int i;
  KeySym key;
  char buf[16];
  
  i = XLookupString(ev, buf, sizeof(buf)-1, &key, NULL);
  buf[i] = '\0';
  switch(buf[0]) {
  case 'F'-0x40:
    key = XK_Right;
    break;
  case 'B'-0x40:
    key = XK_Left;
    break;
  case 'N'-0x40:
    key = XK_Down;
    break;
  case 'P'-0x40:
    key = XK_Up;
    break;
  case 'H'-0x40:
    key = XK_BackSpace;
    break;
  case 'D'-0x40:
    key = XK_Delete;
    break;
  case 'A'-0x40:
    *cursor = 0;
    return 1;
  case 'E'-0x40:
    *cursor = strlen(buffer);
    return 1;
  }
  switch(key) {
  case XK_Right:
    if (*cursor < strlen(buffer)) {
      ++*cursor;
      return 1;
    }
    break;
  case XK_Left:
    if (*cursor > 0) {
      --*cursor;
      return 1;
    }
    break;
  case XK_Up:
  case XK_Down:
    break;
  case XK_BackSpace:
    if (*cursor) {
      --*cursor;
      delete_character(buffer, *cursor);
      return 3;
    }
    break;
  case XK_Delete:
    if (*(buffer+*cursor) != '\0') {
      delete_character(buffer, *cursor);
      return 2;
    }
    break;
  case XK_KP_Enter:
  case XK_Return:
    return 4|3;
  case XK_Escape:
    return 8|3;
  default:
    if (strlen(buf) && buf[0] >= ' ') {
      *cursor += insert_string(buffer, bufferlen, *cursor, buf);
      return 3;
    }
  }
  return 0;
}

/* End of file */
