/* $Header: /home/yav/catty/xpx/xpx/RCS/mag.c,v 1.5 1995/01/08 19:28:34 yav Exp $
 * xpx save load MAG format
 * written by yav (UHD98984@pcvan.or.jp)
 */

#include <X11/Xlib.h>
#include <stdio.h>

#include "xpx.h"

#ifdef HAVE_STRING_H
#include <string.h>
#else
#ifdef HAVE_STRINGS_H
#include <strings.h>
#endif
#endif

#include "extern.h"

static char rcs_id[] = "$Id: mag.c,v 1.5 1995/01/08 19:28:34 yav Exp $";

char mag_magic_number[] = "MAKI02  ";
static char mag_default_user[] = ">\x93\xe4<";

/* store short integer to char buffer as little-endian
 */
void setw(p, n)
     char *p;
     short n;
{
  *p++ = n;
  *p = n >> 8;
}

/* store long integer to char buffer as little-endian
 */
void setl(p, n)
     char *p;
     long n;
{
  *p++ = n;
  *p++ = n >> 8;
  *p++ = n >> 16;
  *p   = n >> 24;
}

/* write MAG palette data
 * Caution! Now supported only 16 colors format
 */
int write_mag_palette_section(fp)
     FILE *fp;
{
  int i;
  COL *cp;
  char buf[3*16], *p;
  
  cp = color_buf;
  p = buf;
  for (i = 0; i < 16; i++) {
    *p++ = cp->rgb.green;
    *p++ = cp->rgb.red;
    *p++ = cp->rgb.blue;
    cp++;
  }
  if (!fwrite(buf, 3*16, 1, fp))
    return 1;
  return 0;
}

int wr_mag(fp)
     FILE *fp;
{
  int i, c, x, y;
  unsigned char *p;
  long l;
  long flagAofs, flagAsize;
  long flagBofs, flagBsize;
  long pixelofs, pixelsize;
  char *username, *comment;
  char buf[512];
  
  username = (char *)getenv("USER");
  if (username == NULL)
    username = mag_default_user;
  sprintf(buf, "%sxpx  %-18.18s ", mag_magic_number, username);
  if (!fwrite(buf, strlen(buf), 1, fp))
    return 1;
  sprintf(buf, "Saved by %s %s", myname, xpx_version);
  comment = buf;
  if (!fwrite(comment, strlen(comment), 1, fp))
    return 1;
  if (!fwrite("\032", 1, 1, fp))
    return 1;
  flagAofs = 32 + 3*16;
  flagAsize = ((imgfilew+3)/4+1)/2;
  flagAsize *= imgfileh;
  if (flagAsize & 1)
    ++flagAsize;
  flagBofs = flagAofs + flagAsize;
  flagBsize = 0;
  pixelofs = flagBofs + flagBsize;
  pixelsize = ((imgfilew+3)/4) * 2;
  bzero(buf, 32);
  setw(buf+8, imgfilew-1);
  setw(buf+10, imgfileh-1);
  setl(buf+12, flagAofs);
  setl(buf+16, flagBofs);
  setl(buf+20, flagBsize);
  setl(buf+24, pixelofs);
  setl(buf+28, pixelsize);
  if (!fwrite(buf, 32, 1, fp))
    return 1;			/* header write error */
  if (write_mag_palette_section(fp))
    return 1;			/* palette write error */
  /* write flagA */
  l = flagAsize;
  bzero(buf, sizeof(buf));
  while (l > 0) {
    i = l < sizeof(buf) ? l : sizeof(buf);
    if (!fwrite(buf, i, 1, fp))
      return 1;			/* flagA write error */
    l -= i;
  }
  /* omit flagB */
  /* write pixel */
  for (y = 0; y < imgfileh; y++) {
    p = imgdata+y*imgmaxw;
    for (x = 0; x < imgfilew; x += 4) {
      buf[0] = *p++;
      buf[0] <<= 4;
      buf[0] |= *p++;
      buf[1] = *p++;
      buf[1] <<= 4;
      buf[1] |= *p++;
      if (!fwrite(buf, 2, 1, fp))
	return 1;		/* pixel write error */
    }
  }
  return 0;
}

int mag_palcnt;
int mag_dataw;
int mag_datah;
int mag_datax;
int mag_datay;

rd_mag(fp)
     FILE *fp;
{
  int w, h;
  
  free_color_all();
  decode_mag(fp, "*noname*");
  get_color(color_buf, mag_palcnt);
  get_requested_colors();
  w = mag_dataw;
  h = mag_datah;
  if (w > imgmaxw) {
    w = imgmaxw;
    message("!\nwidth %d trancate to %d.\n", mag_dataw, w);
  }
  if (h > imgmaxh) {
    h = imgmaxh;
    message("!\nheight %d trancate to %d.\n", mag_datah, h);
  }
  imgupdate(w, h);
  return 0;
}


/* End of file */
