/* $Header: /home/yav/catty/xpx/xpx/RCS/main.c,v 1.53 1995/02/07 15:05:44 yav Exp $
 * xpx main routine
 * written by yav (UHD98984@pcvan.or.jp)
 */

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/cursorfont.h>
#include <X11/keysym.h>
#include <stdio.h>

#include "xpx.h"

#ifdef HAVE_STRING_H
#include <string.h>
#else
#ifdef HAVE_STRINGS_H
#include <strings.h>
#endif
#endif

#include "extern.h"
#include "menudef.h"
#include "editdef.h"

#define COLSETX (PALSETX+32)
#define COLSETY PALSETY

#define INTERNAL_ICONPIXMAP 1

/* #define DEFAULT_FONT "8x13" */
/* #define DEFAULT_BOLD_FONT "8x13bold" */
#define DEFAULT_FONT "-adobe-times-medium-r-normal--14-*"
#define DEFAULT_BOLD_FONT "-adobe-times-bold-r-normal--14-*"

extern MENU colmenu[];
extern char *errname;		/* message.c */
/* file.c */
extern int read_config(
#if NeedFunctionPrototypes
		       void
#endif
		       );
/* sub.c */
extern void cursor_free(
#if NeedFunctionPrototypes
			void
#endif
			);
extern void cursor_busy(
#if NeedFunctionPrototypes
			void
#endif
			);

static char rcs_id[] = "$Id: main.c,v 1.53 1995/02/07 15:05:44 yav Exp $";

char windowname[128];

static char *str_display = "";
static char *str_geometry = "";
static char *str_background = "Wheat";
static char *str_foreground = "Black";
static char *str_border = "Black";
static char *str_font = NULL;
static char *str_fontbold = NULL;
static Bool use_private_color = True;
static char grid_dash_list[2] = {1,1};
static Pixmap icon_pixmap = None;
#ifdef INTERNAL_ICONPIXMAP
#include "icon.xbm"
#endif

usage()
{
  fprintf(stderr, "* %s %s *\n", myname, xpx_version);
  fprintf(stderr, "written by yav (UHD98984@pcvan.or.jp)\n");
  fprintf(stderr, "usage : %s [options] col.kcf rei.cel\n", myname);
  exit(1);
}

char *filename(name)
     char *name;
{
  char *p;
  
  if (name[0] == '\0')
    return "*Noname*";
  p = rindex(name, '/');
  if (p != NULL)
    name = p+1;
  return name;
}

char *basefilename(name)
     char *name;
{
  char *p;
  
  name = filename(name);
  p = rindex(name, '.');
  if (p != NULL)
    *p = '\0';
  return name;
}


#define col8to32(x) (((x)<<24)|((x)<<16)|((x)<<8)|(x))
calcol(col, p)
     XColor *col;
     COL *p;
{
  col->red = col8to32(p->rgb.red);
  col->green = col8to32(p->rgb.green);
  col->blue = col8to32(p->rgb.blue);
  col->flags = DoRed|DoGreen|DoBlue;
}

get_color_sub(i, p)
     COL *p;
{
  XColor col;
  unsigned long plane_masks[1];
  int r;
  
  r = 0;
  calcol(&col, p);
  if (*(coltbl+i) & CM_PRIVATE) {
    col.pixel = *(pixtbl+i);
    XStoreColor(dsp, DefaultColormap(dsp, scr), &col);
  } else {
    if (use_private_color &&
	XAllocColorCells(dsp, DefaultColormap(dsp, scr), False,
			 plane_masks, 0, &col.pixel, 1)) {
      XStoreColor(dsp, DefaultColormap(dsp, scr), &col);
      *(coltbl+i) = CM_ALLOCED | CM_UPDATING | CM_PRIVATE;
      alloced_color++;
    } else if (XAllocColor(dsp, DefaultColormap(dsp, scr), &col)) {
      *(coltbl+i) = CM_ALLOCED | CM_UPDATING;
      alloced_common_color++;
      alloced_color++;
    } else {
      r = 1;			/* alloc error! */
      col.pixel = bg;
    }
    *(pixtbl+i) = col.pixel;
  }
  return r;
}

get_color(p, n)
     COL *p;
{
  int i;
  
  for (i = 0; i < n; i++) {
    if (get_color_sub(i, p))
      message("!color %d %d %d cannot allocated!\n",
	      p->rgb.red, p->rgb.green, p->rgb.blue);
    if (i < MAXCOLSET) {
      XSetForeground(dsp, colgc[i], *(pixtbl+i));
      update_colmenu(i);
    }
    p++;
  }
  return i;
}

/* return number of allocated color */
get_requested_colors()
{
  int i, r;
  
  r = 0;
  for (i = 0; i < MAXCOLSET*MAXPALSET; i++) {
    if (*(coltbl+i) & CM_REQUEST) {
      if (get_color_sub(i, color_buf+i) == 0)
	r++;
      *(coltbl+i) &= ~CM_REQUEST;
    }
  }
  return r;
}

request_color(p)
     COL *p;
{
  int i;
  
  for (i = 0; i < MAXCOLSET*MAXPALSET; i++) {
    if (!(*(coltbl+i) & (CM_ALLOCED|CM_REQUEST))) {
      *(coltbl+i) = CM_REQUEST;
      (color_buf+i)->rgb.red = p->rgb.red;
      (color_buf+i)->rgb.green = p->rgb.green;
      (color_buf+i)->rgb.blue = p->rgb.blue;
      return i;
    }
  }
  return -1;
}

request_color2(i, p)
     COL *p;
{
  *(coltbl+i) = CM_REQUEST;
  (color_buf+i)->rgb.red = p->rgb.red;
  (color_buf+i)->rgb.green = p->rgb.green;
  (color_buf+i)->rgb.blue = p->rgb.blue;
}

init_color()
{
  alloced_color = 0;
  bzero(coltbl, MAXPALSET*MAXCOLSET);
  bzero(colmask, MAXPALSET*MAXCOLSET);
}

/* free common color cells */
free_color()
{
  int i;
  
  for (i = 0; i < MAXPALSET*MAXCOLSET; i++) {
    if ((*(coltbl+i) & CM_ALLOCED)&&!(*(coltbl+i) & CM_PRIVATE)) {
      XFreeColors(dsp, DefaultColormap(dsp, scr), pixtbl+i, 1, 0);
      --alloced_color;
      *(coltbl+i) = 0;
    }
  }
}

/* free common and private color cells */
free_color_all()
{
  int i;
  
  for (i = 0; i < MAXPALSET*MAXCOLSET; i++) {
    if (*(coltbl+i) & CM_ALLOCED) {
      XFreeColors(dsp, DefaultColormap(dsp, scr), pixtbl+i, 1, 0);
      --alloced_color;
      *(coltbl+i) = 0;
    }
  }
}

init_color_buf()
{
  int i, j;
  typedef struct {
    unsigned char r;
    unsigned char g;
    unsigned char b;
  } RGBDATA;
  static RGBDATA initdata[16] = {
    {  0,  0,  0},{  0,  0,255},{255,  0,  0},{255,  0,255},
    {  0,255,  0},{  0,255,255},{255,255,  0},{127,127,127},
    { 64, 64, 64},{127,127,255},{255,127,127},{255,127,255},
    {127,255,127},{127,255,255},{255,255,127},{255,255,255}
  }; 
#define GRAY(n) {n*17, n*17, n*17}
  static RGBDATA initdata1[16] = {
    GRAY(15), GRAY(0), GRAY(1), GRAY(2),
    GRAY(3), GRAY(4), GRAY(5), GRAY(6),
    GRAY(7), GRAY(8), GRAY(9), GRAY(10),
    GRAY(11), GRAY(12), GRAY(13), GRAY(14)
    };
  static RGBDATA initdata2[16] = {
    GRAY(0), GRAY(1), GRAY(2), GRAY(3),
    GRAY(4), GRAY(5), GRAY(6), GRAY(7),
    GRAY(8), GRAY(9), GRAY(10), GRAY(11),
    GRAY(12), GRAY(13), GRAY(14), GRAY(15)
    };
  
  for (i = 0; i < MAXPALSET; i++) {
    for (j = 0; j < MAXCOLSET; j++) {
      (color_buf+MAXCOLSET*i+j)->rgb.padding = 0;
      (color_buf+MAXCOLSET*i+j)->rgb.blue = initdata[j].b;
      (color_buf+MAXCOLSET*i+j)->rgb.red = initdata[j].r;
      (color_buf+MAXCOLSET*i+j)->rgb.green = initdata[j].g;
    }
  }
  for (j = 0; j < MAXCOLSET; j++) {
    (color_buf+MAXCOLSET+j)->rgb.padding = 0;
    (color_buf+MAXCOLSET+j)->rgb.blue = initdata1[j].b;
    (color_buf+MAXCOLSET+j)->rgb.red = initdata1[j].r;
    (color_buf+MAXCOLSET+j)->rgb.green = initdata1[j].g;
  }
  for (j = 0; j < MAXCOLSET; j++) {
    (color_buf+MAXCOLSET*2+j)->rgb.padding = 0;
    (color_buf+MAXCOLSET*2+j)->rgb.blue = initdata2[j].b;
    (color_buf+MAXCOLSET*2+j)->rgb.red = initdata2[j].r;
    (color_buf+MAXCOLSET*2+j)->rgb.green = initdata2[j].g;
  }
#undef GRAY
}

alloc_colorbuf()
{
  color_buf = (COL *)malloc(sizeof(COL)*MAXPALSET*MAXCOLSET);
  pixtbl = (unsigned long *)malloc(sizeof(unsigned long)*MAXPALSET*MAXCOLSET);
  coltbl = (char *)malloc(MAXPALSET*MAXCOLSET);
  colmask = (char *)malloc(MAXPALSET*MAXCOLSET);
  return (color_buf == NULL || pixtbl == NULL ||
	  coltbl == NULL || colmask == NULL);
}

key_event(ev)
     XEvent *ev;
{
  int i, c;
  char buf[32];
  KeySym key;
  XComposeStatus cs;
  
  i = XLookupString((XKeyEvent *)ev, buf, sizeof(buf)-1, &key, &cs);
  buf[i] = '\0';
  switch(key) {
  case XK_Left:
    c = '4';
    break;
  case XK_Right:
    c = '6';
    break;
  case XK_Down:
    c = '2';
    break;
  case XK_Up:
    c = '8';
    break;
  default:
    c = buf[0];
    break;
  }
  switch(c) {
  case 0x03:
  case 'q':
    menu_stat_change(MENU_QUIT, 2);
    break;
  case 'f':
    menu_stat_change(MENU_FILE, 2);
    break;
  case 'i':
    menu_stat_change(MENU_INFO, 2);
    break;
  case 'e':
    menu_stat_change(MENU_EDIT, 2);
    break;
  case '-':
    zoom_out();
    break;
  case '+':
    zoom_in();
    break;
  case 'L'-0x40:
    redraw_window(imgwin);
    break;
  case '2':
  case 'j':
    img_scroll(0, scroll_speed);
    break;
  case '8':
  case 'k':
    img_scroll(0, -scroll_speed);
    break;
  case '6':
  case 'l':
    img_scroll(scroll_speed, 0);
    break;
  case '4':
  case 'h':
    img_scroll(-scroll_speed, 0);
    break;
  case '1':
    img_scroll(-scroll_speed, scroll_speed);
    break;
  case '3':
    img_scroll(scroll_speed, scroll_speed);
    break;
  case '7':
    img_scroll(-scroll_speed, -scroll_speed);
    break;
  case '9':
    img_scroll(scroll_speed, -scroll_speed);
    break;
  case 'p':
    edit_mode_change(EDIT_PLOT);
    break;
  case 'c':
    edit_mode_change(EDIT_COPY);
    break;
  case 'b':
    edit_mode_change(EDIT_FILL);
    break;
  case '!':
    map_message_window();
    break;
  case '?':
    message("imgchanged:%d colchanged:%d\n", imgchanged, colchanged);
    break;
  }
}

string_option(ac, av, r)
     int *ac; char ***av; char **r;
{
  if (*ac > 1) {
    --*ac;
    ++*av;
    *r = **av;
  }
}

f_display(ac, av)
     int *ac; char ***av;
{
  string_option(ac, av, &str_display);
}

f_geometry(ac, av)
     int *ac; char ***av;
{
  string_option(ac, av, &str_geometry);
}

f_background(ac, av)
     int *ac; char ***av;
{
  string_option(ac, av, &str_background);
}

f_foreground(ac, av)
     int *ac; char ***av;
{
  string_option(ac, av, &str_foreground);
}

f_bordercolor(ac, av)
     int *ac; char ***av;
{
  string_option(ac, av, &str_border);
}

f_font(ac, av)
     int *ac; char ***av;
{
  string_option(ac, av, &str_font);
}

f_fontbold(ac, av)
     int *ac; char ***av;
{
  string_option(ac, av, &str_fontbold);
}

f_commoncolor(ac, av)
     int *ac; char ***av;
{
  use_private_color = False;
}

numeric_option(ac, av, r)
     int *ac; char ***av; int *r;
{
  int i;
  char *p;
  
  if (*ac < 1)
    return 0;
  --*ac;
  ++*av;
  i = strtol(**av, &p, 0);
  if (p != **av)
    *r = i;
  return p - **av;
}

f_borderwidth(ac, av)
     int *ac; char ***av;
{
  numeric_option(ac, av, &border_width);
}

f_maxw(ac, av)
     int *ac; char ***av;
{
  numeric_option(ac, av, &imgmaxw);
}

f_maxh(ac, av)
     int *ac; char ***av;
{
  numeric_option(ac, av, &imgmaxh);
}

f_maxz(ac, av)
     int *ac; char ***av;
{
  numeric_option(ac, av, &maxzoom);
  if (zoomfactor > maxzoom)
    zoomfactor = maxzoom;
}

f_scrollspeed(ac, av)
     int *ac; char ***av;
{
  numeric_option(ac, av, &scroll_speed);
}

f_menuspeed(ac, av)
     int *ac; char ***av;
{
  numeric_option(ac, av, &menu_speed);
}

f_ix(ac, av)
     int *ac; char ***av;
{
  numeric_option(ac, av, &imgwx);
}

f_iy(ac, av)
     int *ac; char ***av;
{
  numeric_option(ac, av, &imgwy);
}

f_menu(ac, av)
     int *ac; char ***av;
{
  numeric_option(ac, av, &menumode);
}

f_scrollbar(ac, av)
     int *ac; char ***av;
{
  numeric_option(ac, av, &scrollbarmode);
}

f_backingstore(ac, av)
     int *ac; char ***av;
{
  numeric_option(ac, av, &backingstoremode);
}

f_zoom(ac, av)
     int *ac; char ***av;
{
  numeric_option(ac, av, &zoomfactor);
}

f_quickconvert()
{
  quick_convert = True;
}

f_slowconvert()
{
  quick_convert = False;
}

struct {
  char *name;
  int (*func)();
} opttbl[] = {
  {"-display", f_display},
  {"-geometry", f_geometry},
  {"-background", f_background},
  {"-foreground", f_foreground},
  {"-bordercolor", f_bordercolor},
  {"-borderwidth", f_borderwidth},
  {"-font", f_font},
  {"-bg", f_background},
  {"-fg", f_foreground},
  {"-bd", f_bordercolor},
  {"-bw", f_borderwidth},
  {"-fn", f_font},
  {"-fb", f_fontbold},
  {"-commoncolor", f_commoncolor},
  {"-maxw", f_maxw},
  {"-maxh", f_maxh},
  {"-maxz", f_maxz},
  {"-scrollspeed", f_scrollspeed},
  {"-menuspeed", f_menuspeed},
  {"-?", usage},
  {"-h", usage},
  {"-V", usage},
  {"-help", usage},
  {"-ix", f_ix},
  {"-iy", f_iy},
  {"-menu", f_menu},
  {"-scrollbar", f_scrollbar},
  {"-quickconvert", f_quickconvert},
  {"-slowconvert", f_slowconvert},
  {"-backingstore", f_backingstore},
  {"-zoom", f_zoom},
  {NULL, NULL}
};

create_icon()
{
#ifdef INTERNAL_ICONPIXMAP
#if 1
  icon_pixmap =
    XCreateBitmapFromData(dsp, DefaultRootWindow(dsp), 
			  icon_bits, icon_width, icon_height);
#else
  icon_pixmap =
    XCreatePixmapFromBitmapData(dsp, DefaultRootWindow(dsp), 
				icon_bits, icon_width, icon_height,
				BlackPixel(dsp, scr), WhitePixel(dsp, scr),
				DefaultDepth(dsp, scr));
#endif
  if (icon_pixmap == None) {
    error("icon pixmap create error!");
    return 1;
  }
#endif /* INTERNAL_ICONPIXMAP */
  return create_icon_pixmap();
}

free_icon()
{
  free_icon_pixmap();
  if (icon_pixmap != None)
    XFreePixmap(dsp, icon_pixmap);
}

parse_color(col, name)
     XColor *col;
     char *name;
{
  if (!XParseColor(dsp, DefaultColormap(dsp, scr), name, col)||
      !XAllocColor(dsp, DefaultColormap(dsp, scr), col))
    return error("``%s'' color alloc error!", name);
  return 0;
}

int parse_option(
#if NeedFunctionPrototypes
		 int *ac, char ***av)
#else
     ac, av)
     int *ac;
     char ***av;
#endif
{
  int i;
  
  for (i = 0; opttbl[i].name != NULL; i++) {
    if (strcmp(**av, opttbl[i].name) == 0) {
      opttbl[i].func(ac, av);
      return 0;
    }
  }
  return 1;
}

main(argc, argv)
     int argc; char **argv;
{
  XSizeHints hint;
  XEvent ev;
  int i;
  Window double_click_win = 0;
  Time l, double_click_time;
  XColor col;
  XEvent ahead;
  Bool ignore_event;
  
  oargc = argc;
  oargv = argv;
  errname = myname = filename(*argv);
  strncpy(windowname, myname, sizeof(windowname));
  strncat(windowname, " @ ", sizeof(windowname));
  i = strlen(windowname);
  gethostname(windowname+i, sizeof(windowname)-i);
  windowname[sizeof(windowname)-1] = '\0';
  if (read_config())
    exit(1);
  while (--argc && **++argv == '-') {
    if (parse_option(&argc, &argv))
      return error("unknown option ``%s''!", *argv);
  }
  dsp = XOpenDisplay(str_display);
  if (!dsp) {
    error("Cannot open display!");
    exit(1);
  }
  scr = DefaultScreen(dsp);
  bg = WhitePixel(dsp, scr);
  border_color = fg = BlackPixel(dsp, scr);
  if (parse_color(&col, str_background) == 0)
    bg = col.pixel;
  if (parse_color(&col, str_foreground) == 0)
    fg = col.pixel;
  if (parse_color(&col, str_border) == 0)
    border_color = col.pixel;
  create_icon();
  hint.flags = 0;
  i = XGeometry(dsp, scr, str_geometry, "428x368", border_width, 1, 1, 0, 0,
		&(hint.x), &(hint.y), &(hint.width), &(hint.height));
  if (i & (XValue|YValue))
    hint.flags |= PPosition;
  if (i & (WidthValue|HeightValue))
    hint.flags |= PSize;
  win = XCreateSimpleWindow(dsp, DefaultRootWindow(dsp),
			    hint.x, hint.y, hint.width, hint.height,
			    border_width, border_color, bg);
  XSetStandardProperties(dsp, win, windowname, windowname, icon_pixmap,
			 oargv, oargc, &hint);
  toplevelwin[toplevelwc++] = win;
  curs_watch = XCreateFontCursor(dsp, XC_watch);
  cursor_busy();
  
  if (str_fontbold == NULL)
    str_fontbold = str_font == NULL ? DEFAULT_BOLD_FONT : str_font;
  if (str_font == NULL)
    str_font = DEFAULT_FONT;
  
  fs0 = XLoadQueryFont(dsp, str_fontbold);
  fs1 = XLoadQueryFont(dsp, str_fontbold);
  
  gc0 = XCreateGC(dsp, win, 0, 0);
  XSetBackground(dsp, gc0, bg);
  XSetForeground(dsp, gc0, fg);
  XSetFont(dsp, gc0, fs0->fid);
  
  gc1 = XCreateGC(dsp, win, 0, 0);
  XSetBackground(dsp, gc1, fg);
  XSetForeground(dsp, gc1, bg);
  XSetFont(dsp, gc1, fs0->fid);
  
  areagc = XCreateGC(dsp, win, 0, 0);
  XSetBackground(dsp, areagc, bg);
  XSetForeground(dsp, areagc, fg);
  
  grid0gc = XCreateGC(dsp, win, 0, 0);
  XSetBackground(dsp, grid0gc, bg);
  XSetForeground(dsp, grid0gc, bg);
  
  gridgc = XCreateGC(dsp, win, 0, 0);
  XSetBackground(dsp, gridgc, bg);
  XSetForeground(dsp, gridgc, bg);
  XSetLineAttributes(dsp, gridgc, 0, LineOnOffDash, CapButt, JoinMiter);
  XSetDashes(dsp, gridgc, 0, grid_dash_list, 2);
  
  hatch_pixmap = XCreatePixmapFromBitmapData(dsp, win,
					     hatch_bits, 8, 8, fg, bg,
					     DefaultDepth(dsp, scr));
  
  if (alloc_colorbuf())
    exit(1);
  if (imgwx == -1 && imgwy == -1) {
    if (!menumode) {
      imgwx = imgwy = 0;
    } else {
      imgwx = 112;		/* 124 */
      imgwy = 52;		/* 64 */
    }
    if (scrollbarmode & 1) {
      imgwx += IMGSCRLW;
      imgwy += IMGSCRLW;
    }
  }
  create_img_window();
  
  menuev_init();
  create_message_window();
  create_info_window();
  create_scrlbar_window();
  create_menu_window(win, MENUX, MENUY);
  create_colset_window(win, COLSETX, COLSETY);
  create_palset_window(win, PALSETX, PALSETY);
  create_filename_window(win, PALSETX, PALSETY-24);
  create_zoom_window(win, 256, 4);
  create_grid_window(win, 340, 4);
  create_cursor_window(win, 256, 30);
  create_edit_window();
  create_file_window();
  if (image_alloc()||undo_init()) {
    error("more core!");
    exit(1);
  }
  
  init_color_buf();
  init_color();
  init_image();
  image_update_all();
  while (argc--)
    read_data_file(*argv++);
  XSelectInput(dsp, win, ExposureMask|StructureNotifyMask|
	       ButtonPressMask|KeyPressMask);
  XMapRaised(dsp, win);
  while (!sw_quit) {
    if (XEventsQueued(dsp, QueuedAfterReading) == 0) {
      XFlush(dsp);
      cursor_free();
      imgscrl_background();
      file_background();
    }
    XNextEvent(dsp, &ev);
    ignore_event = False;
    switch(ev.type) {
    case NoExpose:
      if (ev.xnoexpose.drawable == imgwin)
	imgwin_noexpose = True;
      break;
    case GraphicsExpose:
      if (ev.xgraphicsexpose.drawable == imgwin) {
	img_expose(ev.xgraphicsexpose.x, ev.xgraphicsexpose.y,
		   ev.xgraphicsexpose.width, ev.xgraphicsexpose.height);
	if (ev.xgraphicsexpose.count == 0)
	  imgwin_noexpose = True;
      }
      break;
    case Expose:
      if (ev.xexpose.window == imgwin)
	img_expose(ev.xexpose.x, ev.xexpose.y,
		   ev.xexpose.width, ev.xexpose.height);
      else
	info_expose(&ev);
      break;
    case MappingNotify:
      XRefreshKeyboardMapping((XMappingEvent *)&ev);
      break;
    case KeyPress:
      if (ev.xkey.window == win)
	key_event(&ev);
      break;
    case ConfigureNotify:
      if (ev.xconfigure.window == win)
	resize_img_window();
      break;
    case ButtonPress:
      if (ev.xbutton.window == double_click_win) {
	l = ev.xbutton.time - double_click_time;
	if (l & 0x80000000)
	  l = ~l + 1;
	double_clicked = l < 500;
      } else {
	double_clicked = False;
      }
      double_click_win = ev.xbutton.window;
      double_click_time = ev.xbutton.time;
      info_press(&ev);
      break;
    case EnterNotify:
      if (XEventsQueued(ev.xcrossing.display, QueuedAfterReading) > 0) {
	XPeekEvent(ev.xcrossing.display, &ahead);
	if (ahead.type == LeaveNotify &&
	    ahead.xcrossing.window == ev.xcrossing.window &&
	    ahead.xcrossing.mode == ev.xcrossing.mode &&
	    ahead.xcrossing.detail == ev.xcrossing.detail) {
	  XNextEvent(ev.xcrossing.display, &ev);
	  ignore_event = True;
	}
      }
    case LeaveNotify:
      double_click_win = 0;
      break;
    }
    if (!ignore_event) {
      edit_event(&ev);
      menuev_event(&ev);
    }
  }
  autosave();
  update_config_file();
#if 1
  menuev_destroy();
  close_message_window();
  close_edit_window();
  close_info_window();
  close_file_window();
  XDestroyWindow(dsp, imgwin);
  free_color_all();
  free_icon();
  XFree((char *)img);
  XFreeGC(dsp, gc1);
  XFreeGC(dsp, gc0);
  XDestroyWindow(dsp, win);
#endif
  XCloseDisplay(dsp);
  exit(0);
}

/* End of file */
