/* $Header: /home/yav/catty/xpx/xpx/RCS/menu.c,v 1.22 1995/01/07 17:55:27 yav Exp $
 */

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <stdio.h>

#include "xpx.h"
#include "extern.h"
#include "menudef.h"

#define MAXMENU	4
#define MENUW	52
#define MENUH	18

static char rcs_id[] = "$Id: menu.c,v 1.22 1995/01/07 17:55:27 yav Exp $";

static int menu_sw[MAXMENU];

int mnev(
#if NeedFunctionPrototypes
	 MENU *,
	 XEvent *
#endif
	 );

#define IMASK (ExposureMask|EnterWindowMask|LeaveWindowMask|ButtonPressMask)
static MENU menutbl[] = {
  {
    MENU_QUIT,	MenuModeMaskBorder,
    (MENUW+BDW*2+4)*0, 0, MENUW, MENUH,
    0, IMASK, 0,
    mnev, NULL, 0, 0, "Quit"},
  {
    MENU_FILE,	MenuModeMaskBorder,
    (MENUW+BDW*2+4)*1, 0, MENUW, MENUH,
    0, IMASK, 0,
    mnev, NULL, 0, 0, "File"},
  {
    MENU_INFO,	MenuModeMaskBorder,
    (MENUW+BDW*2+4)*2, 0, MENUW, MENUH,
    0, IMASK, 0,
    mnev, NULL, 0, 0, "Info"},
  {
    MENU_EDIT,	MenuModeMaskBorder,
    (MENUW+BDW*2+4)*3, 0, MENUW, MENUH,
    0, IMASK, 0,
    mnev, NULL, 0, 0, "Edit"},
  {
    -1,	0,
    0, 0, 0, 0,
    0, 0, 0,
    NULL, NULL, 0, 0, NULL}};

#define SURE_MESSAGE	0
#define SURE_YES	1
#define SURE_NO		2

int sureev(
#if NeedFunctionPrototypes
	   MENU *,
	   XEvent *
#endif
	   );

static MENU sure_menu[] = {
  {
    SURE_MESSAGE,	0,
    0, 0, 120, 20,
    0, ExposureMask, 0,
    NULL, NULL, 0, 0, "Quit sure?"},
  {
    SURE_YES,	MenuModeMaskBorder,
    80, 20, 32, 20,
    0, IMASK, 0,
    sureev, NULL, 0, 0, "Yes"},
  {
    SURE_NO,	MenuModeMaskBorder,
    80+(32+BDW*2+8), 20, 32, 20,
    0, IMASK, 0,
    sureev, NULL, 0, 0, "No"},
  {
    -1,	0,
    0, 0, 0, 0,
    0, 0, 0,
    NULL, NULL, 0, 0, NULL}};

int sureev(p, ev)
     MENU *p;
     XEvent *ev;
{
  switch(ev->type) {
  case ButtonPress:
    switch(p->n) {
    case SURE_YES:
      sw_quit = 1;
    case SURE_NO:
      menu_stat_change(MENU_QUIT, 0);
      break;
    }
  }
  return 0;
}

static Window surewin;
static int surewin_opened = 0;

void create_sure_window(
#if NeedFunctionPrototypes
			void
#endif
			)
{
  Window root, child;
  int root_x, root_y, win_x, win_y;
  unsigned int keys_buttons;
  char buf[128];
  
  XQueryPointer(dsp, win, &root, &child, &root_x, &root_y,
		&win_x, &win_y, &keys_buttons);
  sprintf(buf, "+%d+%d", root_x, root_y);
  create_toplevel_window(&surewin, "sure?", buf, 180, 50);
  menuwin_create(sure_menu, surewin, 0, 0);
  surewin_opened = 1;
}

void map_sure_window(
#if NeedFunctionPrototypes
		     void
#endif
		     )
{
  if (!surewin_opened)
    create_sure_window();
  sure_menu[SURE_NO].mode &= ~MenuModeMaskOn; /* already off */
  XMapRaised(dsp, surewin);
}

void unmap_sure_window(
#if NeedFunctionPrototypes
		       void
#endif
		       )
{
  XUnmapWindow(dsp, surewin);
}


create_menu_window(win, x, y)
     Window win;
{
  topmenuwin_create(menutbl, x, y);
  return 0;
}

menu_stat_change(i, s)
{
  switch(s) {
  case 0:
    menutbl[i].mode &= ~MenuModeMaskOn;
    break;
  case 1:
    menutbl[i].mode |= MenuModeMaskOn;
    break;
  case 2:
    menutbl[i].mode ^= MenuModeMaskOn;
    break;
  }
  redraw_window(menutbl[i].win);
  switch(i) {
  case MENU_QUIT:
    if (menutbl[i].mode & MenuModeMaskOn) {
      if (imgchanged||colchanged)
	map_sure_window();
      else
	sw_quit = 1;
    } else {
      unmap_sure_window();
    }
    break;
  case MENU_FILE:
    if (menutbl[i].mode & MenuModeMaskOn)
      map_file_window();
    else
      unmap_file_window();
    break;
  case MENU_INFO:
    if (menutbl[i].mode & MenuModeMaskOn)
      map_info_window();
    else
      unmap_info_window();
    break;
  case MENU_EDIT:
    if (menutbl[i].mode & MenuModeMaskOn)
      map_edit_window();
    else
      unmap_edit_window();
    break;
  }
}

int mnev(p, ev)
     MENU *p;
     XEvent *ev;
{
  switch(ev->type) {
  case ButtonPress:
    menu_stat_change(p->n, 2);
    return 1;
  }
  return 0;
}

/* End of file */
