/* $Header: /home/yav/catty/xpx/xpx/RCS/paint.c,v 1.1 1994/09/17 15:27:28 yav Exp $
 * Paint routine for xpx
 * written by yav (UHD98984@pcvan.or.jp)
 */

/* work.c */
extern unsigned char *imgdata;
extern int current_col;
extern int imgmaxw;
extern int imgfilew;
extern int imgfileh;

static char rcs_id[] = "$Id: paint.c,v 1.1 1994/09/17 15:27:28 yav Exp $";
int painted_pixel;

/*
 *   XXX---
 *     ^   <
 */
paint_left(x, y)
     int x;
     int y;
{
  unsigned char *p;
  
  p = imgdata+y*imgmaxw+x;
  while (x >= 0) {
    if (*p != painted_pixel)
      break;
    --p;
    --x;
  }
  return x;
}

/*
 *   ---XXX
 *  >   ^
 */
paint_right(x, y)
     int x;
     int y;
{
  unsigned char *p;

  p = imgdata+y*imgmaxw+x;
  while (x < imgfilew) {
    if (*p != painted_pixel)
      break;
    ++p;
    ++x;
  }
  return x;
}

/*
 *   XXX---
 *  >   ^
 */
paint_next(x, y)
     int x;
     int y;
{
  unsigned char *p;
  
  p = imgdata+y*imgmaxw+x;
  while (x < imgfilew) {
    if (*p == painted_pixel)
      break;
    p++;
    ++x;
  }
  return x;
}

paint(x, y)
     int x;
     int y;
{
  int left, right;
  extern fill_area();		/* convert.c */
  
  left = paint_left(x, y) + 1;
  right = paint_right(x, y) - 1;
  if (left > right)
    return;
  fill_area(left, y, right+1-left, 1, current_col);
#if 0
  area_update(left, y, right+1-left, 1);
#endif
  ++y;
  if (y < imgfileh) {
    /* paint under line */
    for (x = left; x <= right; x = paint_next(x, y))
      paint(x, y);
  }
  y -= 2;
  if (y >= 0) {
    /* paint upper line */
    for (x = left; x <= right; x = paint_next(x, y))
      paint(x, y);
  }
}

/* End of file */
