/* $Header: /home/yav/catty/xpx/xpx/RCS/palset.c,v 1.17 1995/01/07 17:55:27 yav Exp $
 */

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <stdio.h>

#include "xpx.h"

#ifdef HAVE_STRING_H
#include <string.h>
#else
#ifdef HAVE_STRINGS_H
#include <strings.h>
#endif
#endif

#include "extern.h"

#define PALSETW 24
#define PALSETH 18

static char rcs_id[] = "$Id: palset.c,v 1.17 1995/01/07 17:55:27 yav Exp $";

MENU palmenu[MAXPALSET+1];

char *palset_strfunc(p)
     MENU *p;
{
  static char buf[8];
  
  sprintf(buf, "%d", p->n);
  return buf;
}

int palset_event(p, ev)
     MENU *p;
     XEvent *ev;
{
  switch(ev->type) {
  case ButtonPress:
    if (p->n != current_pal) {
      int oldpal;
      
      oldpal = current_pal;
      current_pal = p->n;
      palmenu[oldpal].mode &= ~MenuModeMaskOn;
      redraw_window(palmenu[oldpal].win);
      p->mode |= MenuModeMaskOn;
      redraw_window(p->win);
      color_update_all();
      update_coled_window();
    }
    return 1;
  }
  return 0;
}

create_palset_window(win, x, y)
     Window win;
{
  int i;
  MENU *p;

  p = palmenu;
  for (i = 0; i < MAXPALSET; i++) {
    bzero(p, sizeof(*p));
    p->n = i;
    p->y = (PALSETH+BDW)*i;
    p->w = PALSETW;
    p->h = PALSETH;
    p->im = ExposureMask|EnterWindowMask|LeaveWindowMask|ButtonPressMask;
    p->mode = MenuModeMaskBorder;
    p->event = palset_event;
    p->strfunc = palset_strfunc;
    p++;
  }
  p->n = -1;
  palmenu[current_pal].mode |= MenuModeMaskOn;
  topmenuwin_create(palmenu, x, y);
  return 0;
}

/* End of file */
